//+------------------------------------------------------------------+
//|            MTF_AMA_SLOPE_v24_3x3                   AMA SLOPE.mq4 |
//|            2007   forexTSD.com                    2006   Kalenzo |
//|                                     bartlomiej.gorski@gmail.com  |
//| I used the idea of P.Kauffman and code from KAMA             idk |
//| made by  2004, by konKop,wellx                                  |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

#property indicator_separate_window
#property indicator_buffers 8

#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Aqua
#property indicator_color5 Maroon
#property indicator_color6 Green
#property indicator_color7 LightPink
#property indicator_color8 LightBlue

#property indicator_width1 10
#property indicator_width2 10
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width7 2
#property indicator_width8 2

#property indicator_level3 0.001
#property indicator_level4 -0.001
#property indicator_levelcolor White

//---- input parameters
extern int TimeFrame = 30;
extern int TimeFrame1 = 60;
extern int TimeFrame2 = 240;
extern int       periodAMA=4;
extern int       nfast=2;
extern int       nslow=30;
extern double    G=2.0;
extern int       trigger = 2;
extern color     triggerPlus = Maroon;
extern color     triggerMinus = DarkGreen;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[]; 
double ExtMapBuffer5[];
double ExtMapBuffer6[]; 
double ExtMapBuffer7[]; 
double ExtMapBuffer8[]; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);
   
      
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);   
   SetIndexLabel(2,"AMA_Sl["+TimeFrame+"]("+periodAMA+")("+nfast+","+nslow+")");
   
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   
   SetIndexStyle(4,DRAW_LINE,4,0,triggerMinus);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE,4,0,triggerPlus);
   SetIndexBuffer(5,ExtMapBuffer6);     
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexLabel(6,"AMA_Sl["+TimeFrame1+"]("+periodAMA+")("+nfast+","+nslow+")");
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexLabel(7,"AMA_Sl["+TimeFrame2+"]("+periodAMA+")("+nfast+","+nslow+")");

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//---- name for DataWindow and indicator subwindow label
    if (TimeFrame<Period())  TimeFrame=Period();
    if (TimeFrame1<Period()) TimeFrame1=Period();
    if (TimeFrame2<Period()) TimeFrame2=Period();

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   
IndicatorShortName("MTF_AMA_Slope[["+TimeFrame+"]["+TimeFrame1+"]["+TimeFrame2+"]]("+periodAMA+")("+nfast+","+nslow+")");   

   return(0);
  }
//+------------------------------------------------------------------+
//| Calculations                                                |
//+------------------------------------------------------------------+
int start()
  {
    int i,limit,y=0,y1=0,y2=0,counted_bars=IndicatorCounted();
   
    limit=Bars-counted_bars+2*TimeFrame/Period();
    limit=MathMax(limit,Bars-counted_bars+2*TimeFrame1/Period());
    limit=MathMax(limit,Bars-counted_bars+2*TimeFrame2/Period());

   for(i=limit;i>=0;i--)
   {
      y  = iBarShift(NULL,TimeFrame ,Time[i]);
      y1 = iBarShift(NULL,TimeFrame1,Time[i]); 
      y2 = iBarShift(NULL,TimeFrame2,Time[i]); 

      ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"AmaSlopeV2",periodAMA,nfast,nslow,G, 0,y);
      ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"AmaSlopeV2",periodAMA,nfast,nslow,G, 1,y);
    
      ExtMapBuffer3[i]=iCustom(NULL,TimeFrame,"AmaSlopeV2",periodAMA,nfast,nslow,G, 2,y);
      ExtMapBuffer4[i]=iCustom(NULL,TimeFrame,"AmaSlopeV2",periodAMA,nfast,nslow,G, 3,y);
    
      ExtMapBuffer5[i]= trigger*Point;
      ExtMapBuffer6[i]= -trigger*Point;
      ExtMapBuffer7[i]=iCustom(NULL,TimeFrame1,"AmaSlopeV2",periodAMA,nfast,nslow,G, 0,y1);
      ExtMapBuffer8[i]=iCustom(NULL,TimeFrame2,"AmaSlopeV2",periodAMA,nfast,nslow,G, 0,y2);
   }
   return(0);
}